#include <windows.h>
#include <process.h>
#include <comdef.h>
#include <tchar.h>
#include <time.h>
#include <math.h>
#include "myunintdef.h"
#include "PowerWildCard.h"


void * (* sszrefnewfunc)(intptr_t);
void (* sszrefdeletefunc)(void *);

#include "../../arrayandref.h"

typedef void * (* SSZCALLBACK)(void *, intptr_t, void *, intptr_t, intptr_t);


//////////////////////////////////////////////////////////////////////////
//	function prototype define
#define TUserFunc(FUNC) extern "C" __declspec( dllexport ) intptr_t FUNC(void *argend, int8_t *stack,\
	SSZCALLBACK callback, void *handle, void * (* srn)(intptr_t), void (* srd)(void *))
//////////////////////////////////////////////////////////////////////////

template<typename T> intptr_t XToStr(void *argend, int8_t *stack, void * (* srn)(intptr_t), void (* srd)(void *))
{
	Reference * pr;
	_variant_t comvar;
	wchar_t * str;
	intptr_t idx;
	sszrefnewfunc = srn;
	sszrefdeletefunc = srd;
	pr = (Reference *)*(intptr_t *)((int8_t *)argend - sizeof(intptr_t) - sizeof(T));
	if((intptr_t)pr < 0){
		pr = (Reference *)((intptr_t)pr & INTPTR_MAX);
	}else{
		pr = (Reference *)(stack + (intptr_t)pr);
	}
	comvar = *((T *)argend - 1);
	str = (LPTSTR)(_bstr_t)comvar;
	idx = pr->addsize(lstrlen(str)*sizeof(wchar_t));
	memcpy(pr->obj()->head.data+idx, str, lstrlen(str)*sizeof(wchar_t));
	return sizeof(intptr_t) + sizeof(T);
}

TUserFunc(IntToStr)
{
	return XToStr<long>(argend, stack, srn, srd);
}

TUserFunc(DoubleToStr)
{
	return XToStr<double>(argend, stack, srn, srd);
}

TUserFunc(MojiHyouji)
{
	Reference * p;
	PWCArray<wchar_t> str;
	sszrefnewfunc = srn;
	sszrefdeletefunc = srd;
	p = (Reference *)argend - 1;
	if(p->len() > 0){
		str.AddTail((wchar_t *)p->atpos(), p->len()/sizeof(wchar_t));
		str += L'\0';
		MessageBox(NULL, str.GetConst(), _T("Ă"), MB_OK);
	}
	return sizeof(Reference);
}

TUserFunc(KchirakraOrikaeshi)
{
	callback(handle, *((intptr_t *)argend-1), NULL, 0, 0);
	return sizeof(intptr_t);
}

TUserFunc(ImanoTickCount)
{
	*(uint32_t *)argend = timeGetTime();
	return 0-sizeof(uint32_t);
}

TUserFunc(Sleepinger)
{
	Sleep(*((uint32_t *)argend-1));
	return sizeof(uint32_t);
}

TUserFunc(Power)
{
	*((double *)argend-2) = pow(*((double *)argend-2), *((double *)argend-1));
	return sizeof(double)*2-sizeof(double);
}

int WINAPI MyInputBox(HWND hWndParent, LPTSTR lpszTitle, LPTSTR *Buffer, int *StrLen);
TUserFunc(InputNyuuryoku)
{
	intptr_t ip;
	Reference * p;
	wchar_t * str;
	int len;
	sszrefnewfunc = srn;
	sszrefdeletefunc = srd;
	ip = *((intptr_t *)argend - 1);
	if(ip < 0){
		p = (Reference *)(ip & INTPTR_MAX);
	}else{
		p = (Reference *)(stack + ip);
	}
	p->releaseanddelete();
	len = 0;
	str = NULL;
	MyInputBox(NULL, _T(""), &str, &len);
	p->refnew(len*sizeof(wchar_t));
	memcpy(p->obj()->head.data, str, len*sizeof(wchar_t));
	delete [] str;
	return sizeof(intptr_t);
}

int32_t ransuutane;

TUserFunc(Ransuu)
{
	int32_t w;
	w = ransuutane / 127773;
	if((ransuutane = (ransuutane - w * 127773) * 16807 - w * 2836) <= 0) ransuutane += 2147483647L;
	*(int32_t *)argend = ransuutane;
	return 0-sizeof(int32_t);
}

HINSTANCE ghInstance;

BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
	switch(fdwReason)
	{
	case DLL_PROCESS_ATTACH:
		ghInstance = hinstDLL;
		ransuutane = time(NULL);
		break;

	case DLL_PROCESS_DETACH:
		break;

	case DLL_THREAD_ATTACH:
		break;

	case DLL_THREAD_DETACH:
		break;
	}
	return TRUE;
}

#include "mydll.h"

// Data Structures
typedef struct tagXFERBUFFER2
{
	_TCHAR *lpszTitle;
	LPTSTR *lpszBuffer;
	int *length;
}XFERBUFFER2;
//Prototyping
BOOL WINAPI InputBoxDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
int WINAPI WEP(int nShutDownFlag);
/*******************************************/ 
/* THE FOLLOWING FUNCTION  (WEP) IS    */ 
/* NEEDED FOR EVERY .DLL                   */ 
/*******************************************/ 
int WINAPI WEP(int nShutDownFlag)
{
	return 1;
}
/*******************************************/ 
/* THE FOLLOWING FUNCTION  (MyInputBox) IS*/ 
/* WHAT THE FOXPRO .PRG CALLS*/ 
/*******************************************/ 
/*******************************************/ 
int WINAPI MyInputBox(HWND hWndParent, LPTSTR lpszTitle, LPTSTR *Buffer, int *Length)
{
	DLGPROC lpfnInputBoxDlgProc;
	XFERBUFFER2 XferBuffer;
	int Result;
	XferBuffer.lpszTitle = (_TCHAR *)lpszTitle;
	XferBuffer.lpszBuffer = Buffer;
	XferBuffer.length = Length;
	lpfnInputBoxDlgProc = (DLGPROC)MakeProcInstance((FARPROC)InputBoxDlgProc,
		ghInstance);
	Result=DialogBoxParam(ghInstance,_T("INPUTDIALOG"),
		hWndParent,lpfnInputBoxDlgProc,(LPARAM)&XferBuffer);
	FreeProcInstance((FARPROC)lpfnInputBoxDlgProc);
	return Result;
}
/*******************************************/ 
BOOL WINAPI InputBoxDlgProc(HWND hDlg, UINT message,WPARAM wParam, LPARAM lParam)
{
	static XFERBUFFER2 *XferBuffer;
	switch(message)
	{
	case WM_INITDIALOG :
		{
			XferBuffer = (XFERBUFFER2*)lParam;
			SetWindowText(hDlg, XferBuffer->lpszTitle);
			return TRUE; 
		}
	case WM_COMMAND :
		{
			switch(wParam)
			{
			case IDOK :
				{
					int NumChars;
					*XferBuffer->length = GetWindowTextLength(GetDlgItem(hDlg,IDD_EDIT));
					*XferBuffer->lpszBuffer = new _TCHAR[*XferBuffer->length + 1];
					NumChars=GetDlgItemText(hDlg,IDD_EDIT,
						*XferBuffer->lpszBuffer,
						*XferBuffer->length + 1);
					EndDialog(hDlg,NumChars);
					break; 
				}
			case IDCANCEL :
				{
					EndDialog(hDlg, 0);
					break;
				}
			}
		}
	}
	return FALSE;
}
