#include <windows.h>
#include <process.h>
#include <math.h>
#include "myunintdef.h"
#include "PowerWildCard.h"
#include "LockSingler.h"
#include "StrIdxArray.h"
#include "CommandLine.h"

CommandLineString _cmdline;
PWCArray<_TCHAR> _exedir;

void * MemoryKakuho(intptr_t size)
{
	return new int8_t[size];
}
void MemoryKaihou(void * p)
{
	delete [] (int8_t *)p;
}

void * (* const sszrefnewfunc)(intptr_t) = MemoryKakuho;
void (* const sszrefdeletefunc)(void *) = MemoryKaihou;


#include "arrayandref.h"

#include "typeid.h"

#include "errmes.h"


#include "tokenkind.h"

#include "source.h"

#include "sourcetree.h"

#include "meireicode.h"

#include "compiler.h"

#include "virtualmachine.h"


const _TCHAR * const _dtitle = _T("S-SIZE v1.0");

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance, PSTR szCmdLine,int iCmdShow)
{
	SourceTree sosu;
	PWCArray<uint8_t> byc;
	PWCArray<int8_t> gre;
	OmCompiler omc;
	KasouKikai vm;
	int i;
	_cmdline.set(GetCommandLine());
	for(i = _cmdline.get()[0].GetLength()-1; i >= 0; i--){
		if(_cmdline.get()[0].GetConst()[i] == _T('\\') || _cmdline.get()[0].GetConst()[i] == _T('/')) break;
	}
	_exedir.Clear();
	_exedir.AddTail(_cmdline.get()[0].GetConst(), i+1);
	sosu.Clear();
	if(!sosu.FileRead(_cmdline.count() >= 2 ? _cmdline.get()[1].GetConst() : _T("main.ssz"))){
		ErrorMessage.mes += L'\0';
		MessageBox(NULL, ErrorMessage.mes.GetConst()+1, _dtitle, MB_OK);
		return 0;
	}
	byc.Clear();
	if(!omc.Compile(sosu, byc, gre)){
		ErrorMessage.mes += L'\0';
		MessageBox(NULL, ErrorMessage.mes.GetConst()+1, _dtitle, MB_OK);
		return 0;
	}
	vm.Clear();
	if(!vm.Run(byc, gre)) return 0;
	if(vm.stack.GetLength() != 0){
		MessageBox(NULL, _T("X^bNُłB"), _dtitle, MB_OK);
	}
	return 0;
}
